library(quantreg)
library(foreign)

#change the paths
#data folder
f_data="C:/Users/Blaise/Dropbox/COUNTERFACTUAL/Replication files/Data/"
#results folder
f_results="C:/Users/Blaise/Dropbox/COUNTERFACTUAL/Replication files/Results/"

a=read.dta(paste(f_data,"data.dta",sep=""))
attach(a)
rm(a)
dep=log(wage)
depc=logwc
c=cens
reg=cbind(union, smsa, partt, nonwhite, grade1to4, grade5to6, grade7to8, grade9, grade10, grade11, highschool, somecollege, college, egrade1to4, egrade5to6, egrade7to8, egrade9, egrade10, egrade11, ehighschool, esomecollege, ecollege, exper, exper2, exper3, exper4, oc2, oc3, ind2, ind3, ind4, ind5, ind6, ind7, ind8, ind9, ind10, ind11, ind12, ind13, ind14, ind15, ind16, ind17, ind18, ind19)
ew=eweight/mean(eweight)

wq<-function(y,w,prob){
	o<-order(y)
	y<-y[o]; w<-w[o]
	a<-0; i<-0; s<-sum(w)
	res<-c()
	for(q in prob){
		while(a<q){
			i<-i+1
			a<-a+w[i]/s
		}
		res<-c(res,y[i])
	}
	res
}

est_cqr=function(y,c,x,w,nqreg,c1,c2,nsteps){
	x=cbind(1,x)
	coef=matrix(,ncol(x),nqreg)
	ncensored=(y>c)
	pred=fitted(glm(ncensored~x-1,weights=w,family=binomial(logit)))
	coefqr=est_qr(y,x,w,nqreg)
	for(i in 1:nqreg) {
		quant=i/nqreg-0.5/nqreg
		fit=x%*%coefqr[,i]
		if(sum(fit<c)>0){
			delta1=wq(pred[pred>(1-quant)],w[pred>(1-quant)],c1)
			temps=lm(y[pred>=delta1]~x[pred>=delta1,]-1, weights=w[pred>=delta1])$coef
			reg1=x[,(1:ncol(x))[is.na(temps)==FALSE]]
			temp=temps
			temp[(1:ncol(x))[is.na(temps)==FALSE]]=quantreg(y[pred>=delta1], reg1[pred>=delta1,], w[pred>=delta1], quant)
			temp[(1:ncol(x))[is.na(temps)==TRUE]]=(-100)
			step=3
			while(step<=nsteps){
				pred1=x%*%temp
				delta2=wq(pred1[pred1>c],w[pred1>c],c2)
				temps=lm(y[pred1>=delta2]~x[pred1>=delta2,]-1, weights=w[pred1>=delta2])$coef
				reg1=x[,(1:ncol(x))[is.na(temps)==FALSE]]
				temp=temps
				temp[(1:ncol(x))[is.na(temps)==FALSE]]=quantreg(y[pred1>=delta2], reg1[pred1>=delta2,], w[pred1>=delta2], quant)
				temp[(1:ncol(x))[is.na(temps)==TRUE]]=(-100)
				step=step+1
			}
			coef[,i]=temp
		} else {
			coef[,i]=coefqr[,i]
		}
	}
	coef
}

quantreg=function(y,x,w,quant){
		beta=try(rq.wfit(x,y,weights=w, method="fn", tau=quant)$coef,TRUE)
		if(typeof(beta)=="character") beta=try(rq.wfit(x,y,weights=w, method="pfn", tau=quant)$coef,TRUE)
		if(typeof(beta)=="character") beta=try(rq.wfit(x,y,weights=w, method="br", tau=quant)$coef,TRUE)
		if(max(is.na(beta)[1])==1) beta=rq.wfit(x,y,weights=w, method="br", tau=quant)$coef
		beta
}

est_qr=function(y,x,w,nqreg){
	coef=matrix(,ncol(x),nqreg)
	for(i in 1:nqreg){
		quant=i/nqreg-0.5/nqreg
		coef[,i]=rq.wfit(x,y,weights=w, method="fn", tau=quant)$coef
	}
	coef
}

coefc01=est_cqr(depc[female==0 & wave==1], cens[female==0 & wave==1], reg[female==0 & wave==1,], ew[female==0 & wave==1], 100, 0.1, 0.05, 3)
coefc11=est_cqr(depc[female==1 & wave==1], cens[female==1 & wave==1], reg[female==1 & wave==1,], ew[female==1 & wave==1], 100, 0.1, 0.05, 3)
coefc02=est_cqr(depc[female==0 & wave==2], cens[female==0 & wave==2], reg[female==0 & wave==2,], ew[female==0 & wave==2], 100, 0.1, 0.05, 3)
coefc12=est_cqr(depc[female==1 & wave==2], cens[female==1 & wave==2], reg[female==1 & wave==2,], ew[female==1 & wave==2], 100, 0.1, 0.05, 3)
detach(a)

write.dta(as.data.frame(cbind(coefc01,coefc02,coefc11,coefc12)),file=paste(f_results,"coefinR.dta",sep=""))

#bootstrap 
#function implementing the bootstrap strategy suggested by Bilias, Chen, and Ying (2000, "Simple resampling methods for censored regression quantiles", Journal of econometrics)
est_cqr=function(y, c, x, w, nqreg, coefcqr){
	x=cbind(1,x)
	coef=matrix(,ncol(x),nqreg)
	for(i in 1:nqreg) {
		fit=x%*%coefcqr[,i]
		quant=i/nqreg-0.5/nqreg
		if(length(y[fit>c])>0) temps=lm(y[fit>c]~x[fit>c,]-1, weights=w[fit>c])$coef else temps=rep(NA,nrow(coefcqr))
		temp=temps
		temp[(1:ncol(x))[is.na(temps)==TRUE]]=(-100)
		if(length(y[fit>c])>0){
			reg1=x[,(1:ncol(x))[is.na(temps)==FALSE]]
			temp[(1:ncol(x))[is.na(temps)==FALSE]]=quantreg(y[fit>c], reg1[fit>c,], w[fit>c], quant)
		}
		coef[,i]=temp
	}
	coef
}

for(i in 1:100){
	temp=read.dta(paste(f_data,"boot",i,".dta",sep=""))
	attach(temp)
	dep=log(wage)
	depc=logwc
	c=cens
	reg=cbind(union, smsa, partt, nonwhite, grade1to4, grade5to6, grade7to8, grade9, grade10, grade11, highschool, somecollege, college, egrade1to4, egrade5to6, egrade7to8, egrade9, egrade10, egrade11, ehighschool, esomecollege, ecollege, exper, exper2, exper3, exper4, oc2, oc3, ind2, ind3, ind4, ind5, ind6, ind7, ind8, ind9, ind10, ind11, ind12, ind13, ind14, ind15, ind16, ind17, ind18, ind19)
	ew=eweight/mean(eweight)
	tempc01=est_cqr(depc[female==0 & wave==1], c[female==0 & wave==1], reg[female==0 & wave==1,], ew[female==0 & wave==1], 100, coefc01)
	tempc11=est_cqr(depc[female==1 & wave==1], c[female==1 & wave==1], reg[female==1 & wave==1,], ew[female==1 & wave==1], 100, coefc11)
	tempc02=est_cqr(depc[female==0 & wave==2], c[female==0 & wave==2], reg[female==0 & wave==2,], ew[female==0 & wave==2], 100, coefc02)
	tempc12=est_cqr(depc[female==1 & wave==2], c[female==1 & wave==2], reg[female==1 & wave==2,], ew[female==1 & wave==2], 100, coefc12)
	write.dta(as.data.frame(cbind(tempc01, tempc02, tempc11, tempc12)), file=paste(f_results,"coefinR",i,".dta",sep=""))
	detach(temp)
	rm(temp)
}

